SystemOrganization addCategory: #'OCMS-Kernel'!

Object subclass: #Comment
	instanceVariableNames: 'user dateAndTime text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Kernel'!

!Comment commentStamp: 'HAS 4/30/2013 20:35' prior: 0!
I represent comments made by users regarding the courseware.!

!Comment methodsFor: 'accessing' stamp: 'HAS 4/30/2013 20:09'!
dateAndTime

	^ dateAndTime! !

!Comment methodsFor: 'accessing' stamp: 'HAS 4/30/2013 20:09'!
dateAndTime: aDateAndTime

	dateAndTime := aDateAndTime! !

!Comment methodsFor: 'accessing' stamp: 'HAS 4/30/2013 20:08'!
text

	^ text! !

!Comment methodsFor: 'accessing' stamp: 'HAS 4/30/2013 20:08'!
text: aText

	text := aText! !

!Comment methodsFor: 'accessing' stamp: 'HAS 4/30/2013 20:07'!
user

	^ user! !

!Comment methodsFor: 'accessing' stamp: 'HAS 4/30/2013 20:07'!
user: anUser

	user := anUser! !

Object subclass: #Course
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Kernel'!

!Course commentStamp: 'oda 5/1/2013 20:50' prior: 0!
Not implemented yet.!

Object subclass: #Courseware
	instanceVariableNames: 'id title description summary coursewareType owner reference tag classification author creationDateTime modificationDateTime cataloguingData license size comment score permission enabled downloadCounter file'
	classVariableNames: 'CoursewareTypeList'
	poolDictionaries: ''
	category: 'OCMS-Kernel'!

!Courseware commentStamp: 'HAS 4/28/2013 17:10' prior: 0!
Contains information about courseware

Instance variables:
	id <Long>										Unique identification
	title <String>										Title
	description <String>								Description
	summary <String>								A summary of the courseware's contents (optional)
	coursewareType <Symbol>						Type of courseware getting from CoursewareTypeSet class variable
	owner <User>									User that upload the courseware	
	reference <String>								Information about authors, journal, url, related courseware,...
	tag <List of: Tag>								A sorted list of tags related
	classification <List of: Discipline>					Disciplines/Areas related to the courseware
	author <List of: String>							Author(s) of the courseare in a ordered list
	creationDateTime <DateAndTime>					Date and time in which the courseware was uploaded
	modificationDateTime <DateAndTime>				Date and time of the last modification of the courseware
	cataloguingData <String>							Information about cataloguing data.
	license <LicenseType>							Type of license described in LicenseTypeSet class variable
	size <Integer>									Size of the courseware in K bytes
	comment <List of: Comment>						A list of comments of the courseware
	score <Map of: User and Float>					A map representing the score atributed by each user
	permission <Map of: User and PermissionType>	A map associating user and type of permission that they have
	enabled <Boolean>								A flag that indicates if the courseware is enable or not
	downloadCounter <Integer>						Number of downloads of the courseware
	file <File>										File name and extension of courseware!

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/30/2013 10:51'!
CoursewareTypeList
	^ CoursewareTypeList! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 16:49'!
author
	^ author! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 16:50'!
author: anOrderedCollectionString
	author := anOrderedCollectionString! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 16:58'!
cataloguingData
	^ cataloguingData! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 16:58'!
cataloguingData: aString
	cataloguingData := aString! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 16:42'!
classification
	^classification! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 17:06'!
classification: aSortedCollectionDiscipline
	classification := aSortedCollectionDiscipline! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 17:01'!
comment
	^ comment! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/30/2013 23:14'!
comment: anOrderedCollectionComment
	comment := anOrderedCollectionComment! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/27/2013 15:22'!
coursewareType
	^ coursewareType! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/30/2013 11:03'!
coursewareType: aSymbol
	(CoursewareTypeList includes: aSymbol)
		ifTrue:[coursewareType := aSymbol]
		ifFalse:[self error: 'This CoursewareType does not exist']! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 16:57'!
creationDateTime
	^ creationDateTime! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 16:57'!
creationDateTime: aDateAndTime
	creationDateTime := aDateAndTime! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/27/2013 15:18'!
description
	^ description! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/27/2013 15:19'!
description: aString
	description := aString! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 17:08'!
downloadCounter
	^ downloadCounter! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 17:08'!
downloadCounter: anInteger
	downloadCounter := anInteger! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 17:04'!
enabled
	^ enabled! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 17:04'!
enabled: aBoolean
	enabled := aBoolean! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 17:09'!
file
	^ file! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 17:09'!
file: aFile
	file := aFile! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/27/2013 12:18'!
id
	^ id! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 18:29'!
id: anInteger
	(anInteger isInteger)
	ifTrue:[id := anInteger]
	ifFalse:[self error: 'The value must be an integer']! !

!Courseware methodsFor: 'initialize' stamp: 'HAS 4/30/2013 20:34'!
initialize
	CoursewareTypeList := #(Audio Code Exercise Program Slide Text Video).
	self downloadCounter: 0.
	self enabled: true.
	self permission: Dictionary new.
	self comment: OrderedCollection new.! !

!Courseware methodsFor: 'testing' stamp: 'HAS 4/28/2013 19:54'!
isCourseware
	^true! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 16:59'!
license
	^ license! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 16:59'!
license: aLicense
	license := aLicense! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/29/2013 19:50'!
modificationDateTime
	^ modificationDateTime! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/29/2013 19:50'!
modificationDateTime: aDateAndTime
	modificationDateTime := aDateAndTime! !

!Courseware methodsFor: 'instance creation' stamp: 'HAS 4/30/2013 10:48'!
new
	| newCourseware |
	
	newCourseware := super.
	newCourseware initialize.
	^newCourseware
! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 01:09'!
owner
	^ owner! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 07:44'!
owner: aUser
	owner := aUser! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 17:03'!
permission
	^ permission! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 17:05'!
permission: aMapOfUserAndPermissionType
	permission := aMapOfUserAndPermissionType! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 07:58'!
reference
	^ reference! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 07:59'!
reference: aString
	reference := aString! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 17:01'!
score
	^ score! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 17:05'!
score: aMapOfUserAndFloat
	score := aMapOfUserAndFloat! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 17:00'!
size
	^ size! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 17:00'!
size: aFloat
	size := aFloat! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/27/2013 15:20'!
summary
	^ summary! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/27/2013 15:19'!
summary: aString
	summary := aString! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 16:40'!
tag
	^tag! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/29/2013 21:09'!
tag: aOrderedCollectionTag
	| tagVariable |
	(aOrderedCollectionTag isMemberOf: OrderedCollection)
		ifFalse: [self error: 'This method must receives a OrderedCollection of Tag']
		ifTrue: [(aOrderedCollectionTag isEmpty not)
					ifFalse: [self error: 'This method must receives a OrderedCollection not empty']
					ifTrue: [tagVariable := aOrderedCollectionTag at: 1.
							(tagVariable isTag)
								ifTrue: [tag := aOrderedCollectionTag]
								ifFalse: [self error: 'This method must receives a OrderedCollection of Tag']
					]
		]! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/27/2013 14:00'!
title
	^ title! !

!Courseware methodsFor: 'accessing' stamp: 'HAS 4/28/2013 17:38'!
title: anString
	title := anString! !

Object subclass: #CoursewareManager
	instanceVariableNames: 'courseware'
	classVariableNames: 'PermissionType'
	poolDictionaries: ''
	category: 'OCMS-Kernel'!

!CoursewareManager commentStamp: 'HAS 4/29/2013 10:31' prior: 0!
This class manages coursewares, which include methods to search, edit and classify a courseware.

	courseware <Courseware>	Represent a courseware!

!CoursewareManager methodsFor: 'accessing' stamp: 'HAS 4/30/2013 18:06'!
blockCourseware: aCourseware user: anUser
	"i block the couseware if the user has the permissions to do this"

	"(anUser isProfessorAt: aCourseware classification)"
	aCourseware enabled: false.
	^ aCourseware! !

!CoursewareManager methodsFor: 'accessing' stamp: 'HAS 4/29/2013 10:32'!
courseware
	^ courseware! !

!CoursewareManager methodsFor: 'accessing' stamp: 'HAS 4/29/2013 10:33'!
courseware: aCourseware
	courseware := aCourseware! !

!CoursewareManager methodsFor: 'accessing' stamp: 'HAS 4/29/2013 11:14'!
getMaxCoursewareId
	| maxCoursewareId |
	
	"get max id from DB instead of the below line"
	maxCoursewareId := 10.
	^ maxCoursewareId! !

!CoursewareManager methodsFor: 'accessing' stamp: 'HAS 4/30/2013 23:46'!
includeComment: aCourseware comment: aComment
	"i include a comment of an user in courseware"
	
	| commentCollection |
	
	commentCollection := aCourseware comment.
	commentCollection add: aComment.
	aCourseware comment: commentCollection.
	^ aCourseware! !

!CoursewareManager methodsFor: 'accessing' stamp: 'HAS 4/29/2013 19:50'!
includeCourseware: aTitle description: aDescription summary: aSummary coursewareType: aCoursewareType reference: aReference owner: aOwner tag: aTag classification: aListDiscipline author: aListAuthor cataloguingData: aCataloguingData license: aLicenseType size: aSize permission: aMapUserPermissionType file: aFile

| coursewareTemp |
coursewareTemp := Courseware new.
coursewareTemp id: self incrementCoursewareId.
coursewareTemp title: aTitle.
coursewareTemp description: aDescription.
coursewareTemp summary: aSummary.
coursewareTemp coursewareType: aCoursewareType.
coursewareTemp owner: aOwner.
coursewareTemp reference: aReference.
coursewareTemp tag: aTag.
coursewareTemp classification: aListDiscipline.
coursewareTemp author: aListAuthor.
coursewareTemp creationDateTime: DateAndTime now.
coursewareTemp modificationDateTime: nil.
coursewareTemp cataloguingData: aCataloguingData.
coursewareTemp license: aLicenseType.
coursewareTemp size: aSize.
coursewareTemp comment: nil.
coursewareTemp score: nil.
coursewareTemp permission: aMapUserPermissionType.
coursewareTemp enabled: true.
coursewareTemp downloadCounter: 0.
coursewareTemp file: aFile.
courseware := coursewareTemp.! !

!CoursewareManager methodsFor: 'accessing' stamp: 'HAS 4/30/2013 16:42'!
includeOrUpdateCoursewareScore: aCourseware user: anUser score: aScore

	"include a score for the courseware gave by an User"

	| scoreDictionary login |

	"Change for User class"
	"login: anUser login"
	login := anUser.

	scoreDictionary := aCourseware score.
	scoreDictionary at: login put: aScore.
	aCourseware score: scoreDictionary.
	^aCourseware! !

!CoursewareManager methodsFor: 'accessing' stamp: 'HAS 4/30/2013 19:56'!
includeOrUpdatePermission: aCourseware user: anUser permission: aPermissionType
	"i include or update permissions to user read and write coursewares"
	
	| permissionDictionary login |
	
	"Change for User class"
	"login: anUser login"
	login := anUser.

	"(anUser isProfessorAt: aCourseware classification)(anUserManager isAdmin: anUser)"
	(PermissionType includes: aPermissionType)
		ifTrue:[
				permissionDictionary := aCourseware permission.
				permissionDictionary at: login put: aPermissionType.
				aCourseware permission: permissionDictionary.
				^aCourseware
				]
		ifFalse:[self error: 'This PermissionType does not exist']! !

!CoursewareManager methodsFor: 'accessing' stamp: 'HAS 4/29/2013 11:12'!
incrementCoursewareId
	| maxCoursewareId |
	
	maxCoursewareId := self getMaxCoursewareId.
	^ maxCoursewareId + 1! !

!CoursewareManager methodsFor: 'accessing' stamp: 'HAS 4/30/2013 17:11'!
incrementDownloadCounter: aCourseware

	"increase the number of downloads of a courseware"

	aCourseware downloadCounter: aCourseware downloadCounter + 1.
	^ aCourseware! !

!CoursewareManager methodsFor: 'initialize' stamp: 'HAS 4/30/2013 18:43'!
initialize

	PermissionType := #(Read ReadAndWrite)! !

!CoursewareManager methodsFor: 'accessing' stamp: 'HAS 4/30/2013 18:07'!
unblockCourseware: aCourseware user: anUser
	"i block the couseware if the user has the permissions to do this"

	"(anUser isProfessorAt: aCourseware classification)"
	aCourseware enabled: true.
	^ aCourseware! !

!CoursewareManager methodsFor: 'accessing' stamp: 'HAS 4/30/2013 15:06'!
updateCourseware: aCourseware title: aTitle description: aDescription summary: aSummary coursewareType: aCoursewareType reference: aReference tag: aTag classification: aListDiscipline author: aListAuthor cataloguingData: aCataloguingData license: aLicenseType size: aSize score: aMapUserFloat permission: aMapUserPermissionType file: aFile

| coursewareTemp |
coursewareTemp := aCourseware.
coursewareTemp title: aTitle.
coursewareTemp description: aDescription.
coursewareTemp summary: aSummary.
coursewareTemp coursewareType: aCoursewareType.
coursewareTemp reference: aReference.
coursewareTemp tag: aTag.
coursewareTemp classification: aListDiscipline.
coursewareTemp author: aListAuthor.
coursewareTemp modificationDateTime: DateAndTime now.
coursewareTemp cataloguingData: aCataloguingData.
coursewareTemp license: aLicenseType.
coursewareTemp size: aSize.
coursewareTemp score: aMapUserFloat.
coursewareTemp permission: aMapUserPermissionType.
coursewareTemp file: aFile.
courseware := coursewareTemp.! !

Object subclass: #Tag
	instanceVariableNames: 'name relatedTag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Kernel'!

!Tag commentStamp: 'HAS 4/28/2013 16:34' prior: 0!
Store the tags used to classify courseware.

	name <String>							Name of the tag.
	relatedTag <OrderedCollection of: Tag>		Contains the related tags.!

!Tag methodsFor: 'testing' stamp: 'HAS 4/28/2013 19:52'!
isTag
	^ true! !

!Tag methodsFor: 'accessing' stamp: 'HAS 4/28/2013 15:54'!
name
	^name! !

!Tag methodsFor: 'accessing' stamp: 'HAS 4/28/2013 15:59'!
name: aString
	"Verify if the tag already exists"
	name := aString
	! !

!Tag methodsFor: 'accessing' stamp: 'HAS 4/28/2013 16:05'!
relatedTag
	^relatedTag! !

!Tag methodsFor: 'accessing' stamp: 'HAS 4/29/2013 21:04'!
relatedTag: aOrderedCollection
	relatedTag := aOrderedCollection
	! !

Object subclass: #User
	instanceVariableNames: 'name email login password isAdmin isEnabled courseRole'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Kernel'!

!User commentStamp: 'oda 5/1/2013 20:21' prior: 0!
Contains information about user.

Instance Variables
	disciplineRole <Dictionary<Discipline, UserType>>		stores the role of the user within a discipline
	email <String>
	isEnabled <Boolean>
	isAdmin <Boolean>
	login <String>
	name <String>
	password <String>
!

!User methodsFor: 'comparing' stamp: 'oda 5/1/2013 23:43'!
= aUser
	(aUser isMemberOf: User)
	ifFalse: [self error: 'Comparing User class with a different class.']
	ifTrue: [^self login = aUser login]! !

!User methodsFor: 'accessing' stamp: 'oda 5/1/2013 23:50'!
course
	"Answer the courses that the user has a role in"
	
	^ courseRole keys! !

!User methodsFor: 'accessing' stamp: 'oda 5/1/2013 20:41'!
email
	^ email! !

!User methodsFor: 'accessing' stamp: 'oda 5/1/2013 20:41'!
email: aString
	email := aString! !

!User methodsFor: 'comparing' stamp: 'oda 5/1/2013 22:59'!
hash
	^ login hash! !

!User methodsFor: 'accessing' stamp: 'oda 5/3/2013 21:40'!
includeOrUpdateCourse: aCourse withRole: aRole
	"Includes/updates an user role within a course.
	Use UserType methods the get a role."
	
	((aCourse isMemberOf: Course) and: [UserType UserTypeList includes: aRole])
		ifTrue: [courseRole at: aCourse put: aRole]
		ifFalse: [self error: 'The course must be instance of Course class and the role must come from the UserType methods.']
	! !

!User methodsFor: 'initialize-release' stamp: 'oda 5/3/2013 21:35'!
initialize
	isEnabled := false.
	isAdmin := false.
	courseRole := Dictionary new.
	
	! !

!User methodsFor: 'accessing' stamp: 'oda 5/1/2013 20:41'!
isAdmin
	^ isAdmin! !

!User methodsFor: 'accessing' stamp: 'oda 5/1/2013 21:03'!
isAdmin: aBoolean
	isAdmin := aBoolean! !

!User methodsFor: 'accessing' stamp: 'oda 5/1/2013 20:41'!
isEnabled
	^ isEnabled! !

!User methodsFor: 'accessing' stamp: 'oda 5/1/2013 20:58'!
isEnabled: aBoolean
	isEnabled := aBoolean! !

!User methodsFor: 'accessing' stamp: 'oda 5/1/2013 20:58'!
login
	^ login! !

!User methodsFor: 'accessing' stamp: 'oda 5/1/2013 20:58'!
login: aString
	login := aString! !

!User methodsFor: 'accessing' stamp: 'oda 5/1/2013 20:58'!
name
	^ name! !

!User methodsFor: 'accessing' stamp: 'oda 5/1/2013 20:59'!
name: aString
	name := aString! !

!User methodsFor: 'accessing' stamp: 'oda 5/1/2013 20:42'!
password
	^ password! !

!User methodsFor: 'accessing' stamp: 'oda 5/1/2013 20:59'!
password: aString
	password := aString! !

!User methodsFor: 'accessing' stamp: 'oda 5/1/2013 21:00'!
roleAtCourse: aCourse
	"Answer the role of user within a course"

	(aCourse isMemberOf: Course)
	ifTrue: [^courseRole at: aCourse]
	ifFalse: [self error: 'The course must be instance of Course class.']
	! !

Object subclass: #UserManager
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Kernel'!

!UserManager commentStamp: 'oda 5/3/2013 22:00' prior: 0!
Manages users, can include new users, update existing ones, block/unblock users and is responsible for authentication.

Instance Variables
	user:<Set<User>>!

!UserManager methodsFor: 'accessing' stamp: 'oda 5/3/2013 21:47'!
authenticateUserWithLogin: aLogin withPassword: aPassword
	"Asserts if user with aLogin exists and the password is correct."
	| anUser |
	anUser := self userWithLogin: aLogin.
	(anUser password = aPassword)
		ifTrue: [^true]
		ifFalse: [^false]! !

!UserManager methodsFor: 'accessing' stamp: 'oda 5/2/2013 00:46'!
blockUser: anUser
	"Blocks user."
	(anUser isMemberOf: User)
	ifFalse: [self error: 'The parameter must be member of the class User.']
	ifTrue: [
		(user includes: anUser)
			ifTrue: [
				| oldUser |
				oldUser := user array at:(user scanFor: anUser).
				oldUser isEnabled: false.
				^oldUser.
			]
			ifFalse: [self error: 'The login of this user does not exists.']
	]! !

!UserManager methodsFor: 'accessing' stamp: 'oda 5/2/2013 00:46'!
blockUserWithLogin: aLogin
	"Blocks user"
	| anUser |
	anUser := User new login: aLogin.
	self blockUser: anUser.! !

!UserManager methodsFor: 'accessing' stamp: 'oda 5/2/2013 00:09'!
includeUser: newUser
	"Includes a new user."
	(newUser isMemberOf: User)
	ifFalse: [self error: 'The parameter must be member of the class User.']
	ifTrue: [
		(user includes: newUser)
			ifTrue: [self error: 'This login is already included']
			ifFalse: [^user add: newUser]
	]! !

!UserManager methodsFor: 'accessing' stamp: 'oda 5/2/2013 00:05'!
includeUserWithLogin: aLogin withPassword: aPassword withEmail: anEmail withName: aName isAdmin: anAdminFlag
	"Includes a new user."
	| newUser |
	newUser := User new login: aLogin;
						password: aPassword;
						email: anEmail;
						name: aName;
						isAdmin: anAdminFlag.
	^self includeUser: newUser.! !

!UserManager methodsFor: 'initialize-release' stamp: 'oda 5/1/2013 20:39'!
initialize
	user := Set new.! !

!UserManager methodsFor: 'accessing' stamp: 'oda 5/2/2013 00:11'!
removeUser: anUser
	"Removes user"
	(anUser isMemberOf: User)
	ifFalse: [self error: 'The parameter must be member of the class User.']
	ifTrue: [user remove: anUser]! !

!UserManager methodsFor: 'accessing' stamp: 'oda 5/2/2013 00:11'!
removeUserWithLogin: aLogin
	"Removes user"
	| anUser |
	anUser := User new login: aLogin.
	self removeUser: anUser.! !

!UserManager methodsFor: 'accessing' stamp: 'oda 5/3/2013 21:42'!
unblockUser: anUser
	"Unblocks user."
	(anUser isMemberOf: User)
	ifFalse: [self error: 'The parameter must be member of the class User.']
	ifTrue: [
		(user includes: anUser)
			ifTrue: [
				| oldUser |
				oldUser := user array at:(user scanFor: anUser).
				oldUser isEnabled: true.
				^oldUser.
			]
			ifFalse: [self error: 'The login of this user does not exists.']
	]! !

!UserManager methodsFor: 'accessing' stamp: 'oda 5/3/2013 21:43'!
unblockUserWithLogin: aLogin
	"Unblocks user"
	| anUser |
	anUser := User new login: aLogin.
	self unblockUser: anUser.! !

!UserManager methodsFor: 'accessing' stamp: 'oda 5/2/2013 00:30'!
updateUser: anUser
	"Updates an user."
	(anUser isMemberOf: User)
	ifFalse: [self error: 'The parameter must be member of the class User.']
	ifTrue: [
		(user includes: anUser)
			ifTrue: [
				| oldUser |
				oldUser := user array at:(user scanFor: anUser).
				oldUser password: anUser password.
				oldUser email: anUser email.
				oldUser name: anUser name.
				oldUser isAdmin: anUser isAdmin.
				^oldUser.
			]
			ifFalse: [self error: 'The login of this user does not exists.']
	]! !

!UserManager methodsFor: 'accessing' stamp: 'oda 5/2/2013 00:24'!
updateUserWithLogin: aLogin withPassword: aPassword withEmail: anEmail withName: aName isAdmin: anAdminFlag
	"Updates an user."
	| anUser |
	anUser := User new login: aLogin;
						password: aPassword;
						email: anEmail;
						name: aName;
						isAdmin: anAdminFlag.
	^self updateUser: anUser.! !

!UserManager methodsFor: 'accessing' stamp: 'oda 5/1/2013 23:50'!
user
	"Returns the users in the UserManager"

	^user! !

!UserManager methodsFor: 'accessing' stamp: 'oda 5/2/2013 01:10'!
userWithLogin: aLogin
	"Returns the user with the specified login"
	| anUser |
	anUser := (user array at: (user scanFor: (User new login: aLogin))).
	anUser ifNil: [self error: 'The login of this user does not exists.'].
	^anUser! !

Object subclass: #UserType
	instanceVariableNames: ''
	classVariableNames: 'UserTypeList'
	poolDictionaries: ''
	category: 'OCMS-Kernel'!

!UserType commentStamp: 'oda 5/1/2013 20:25' prior: 0!
UserType class is used to enumerate roles of users, so it can be used to set roles of users within Disciplines.

There are the following roles that can be accessed by class methods:
	student
	professor

UserTypeList is a class variable that contains a set with all roles availables.
!

!UserType class methodsFor: 'class variables' stamp: 'oda 5/1/2013 19:02'!
UserTypeList
	UserTypeList ifNil: [UserTypeList := Set new add: UserType professor; add: UserType student; yourself].
	^ UserTypeList! !

!UserType class methodsFor: 'instance creation' stamp: 'oda 5/1/2013 18:13'!
new
	self error: 'This class should not be instanciated'! !

!UserType class methodsFor: 'acessing' stamp: 'oda 5/1/2013 20:19'!
professor
	^ #ProfessorRole! !

!UserType class methodsFor: 'acessing' stamp: 'oda 5/1/2013 20:19'!
student
	^ #StudentRole! !
